{*********************************************************************}

function Lowercase(Letter : char) : char;

  {-------------------------------------------------------------------}
  {  Lowercase is used to convert alphabetic characters to lower      }
  {  case.  If the input parameter is an upper case letter            }
  {  ('A' through 'Z'), the value of the function is the corresponding}
  {  lower case letter ('a' through 'z').  If the input parameter is  }
  {  any other character, the value of the function is equal to the   }
  {  input parameter.                                                 }
  {                                                                   }
  {  Input parameters:                                                }
  {    Letter - character to be converted to lower case               }
  {                                                                   }
  {  Output parameters : None                                         }
  {                                                                   }
  {  Function value : the value of the input parameter Letter,        }
  {                   converted to lower case if it was originally    }
  {                   in the range 'A' through 'Z'                    }
  {-------------------------------------------------------------------}

  var
    ConvertedLetter : char;       { the function value being computed }
    DistancePastA : integer;      { the distance in the alphabet between
                                    the letter being converted and 'A' }
  begin  { Lowercase }

    { if the input parameter is an upper case letter, convert it to
      the corresponding lower case letter.  otherwise, the converted
      letter is set equal to the input parameter. }

    if Letter in ['A'..'Z'] then
      begin
        DistancePastA := ord(Letter) - ord('A');
        ConvertedLetter := chr(ord('a') + DistancePastA)
      end  { if }
    else
      ConvertedLetter := Letter;

    { set the function value }

    Lowercase := ConvertedLetter

  end;  { Lowercase }

{*********************************************************************}

function Uppercase(Letter : char) : char;

  {-------------------------------------------------------------------}
  {  Uppercase is used to convert alphabetic characters to upper      }
  {  case.  If the input parameter is a lower case letter             }
  {  ('a' through 'z'), the value of the function is the corresponding}
  {  upper case letter ('A' through 'Z').  If the input parameter is  }
  {  any other character, the value of the function is equal to the   }
  {  input parameter.                                                 }
  {                                                                   }
  {  Input parameters:                                                }
  {    Letter - character to be converted to upper case               }
  {                                                                   }
  {  Output parameters : None                                         }
  {                                                                   }
  {  Function value : the value of the input parameter Letter,        }
  {                   converted to upper case if it was originally    }
  {                   in the range 'a' through 'z'                    }
  {-------------------------------------------------------------------}

  var
    ConvertedLetter : char;       { the function value being computed }
    DistancePastA : integer;      { the distance in the alphabet between
                                    the letter being converted and 'a' }
  begin  { Uppercase }

    { if the input parameter is a lower case letter, convert it to
      the corresponding upper case letter.  otherwise, the converted
      letter is set equal to the input parameter. }

    if Letter in ['a'..'z'] then
      begin
        DistancePastA := ord(Letter) - ord('a');
        ConvertedLetter := chr(ord('A') + DistancePastA)
      end  { if }
    else
      ConvertedLetter := Letter;

    { set the function value }

    Uppercase := ConvertedLetter

  end;  { Uppercase }

