{*********************************************************************}

{ ## Non-standard statements -- Berkeley Pascal version }
{
procedure ClrScr; external;
}
{ End Berkeley Pascal version }

procedure ClearScreen;

  {-------------------------------------------------------------------}
  {  ClearScreen clears the terminal screen and positions the         }
  {  cursor at the upper left corner of the screen.  It calls a       }
  {  non-standard Pascal library routine to perform this operation.   }
  {-------------------------------------------------------------------}

  begin

    ClrScr   { call library routine ClrScr to clear screen }

  end;  { ClearScreen }

{*********************************************************************}

{ ## Non-standard statements -- Berkeley Pascal version }
{
procedure GotoXY(X, Y : integer); external;
}
{ End Berkeley Pascal version }

procedure MoveCursor(Row, Col : integer);

  {-------------------------------------------------------------------}
  {  MoveCursor moves the cursor on the terminal screen to the        }
  {  row and column given by its input parameters.  The next write    }
  {  or writeln operation that sends output to the terminal will      }
  {  begin writing at the row and column location designated.  The    }
  {  procedure calls a non-standard Pascal library routine to perform }
  {  this operation.                                                  }
  {                                                                   }
  {  Input parameters:                                                }
  {    Row,Col - the row (line) and column (horizontal position) on   }
  {          the screen to which the cursor is to be moved.  The      }
  {          upper left-hand corner of the screen is row 1, column 1. }
  {-------------------------------------------------------------------}

  begin

    { call library routine GotoXY to move the cursor -- note that
      GotoXY expects the column value as its first parameter }

    GotoXY(Col,Row)

  end;  { MoveCursor }

{*********************************************************************}

{ ## Non-standard statements -- Berkeley Pascal version }
{
procedure ClrEol; external;
}
{ End Berkeley Pascal version }

procedure ClearLine;

  {-------------------------------------------------------------------}
  {  ClearLine clears the line on the terminal screen where the       }
  {  cursor is currently positioned, from the cursor position to the  }
  {  end of the line.  It calls a non-standard Pascal library routine }
  {  to perform this function.                                        }
  {-------------------------------------------------------------------}

  begin

    ClrEol     { call library routine ClrEol to clear line }

  end;  { ClearLine }

