program TestUppercase(input,output);

{---------------------------------------------------------------------}
{  This program tests the function Uppercase.  It prompts the user to }
{  enter a character from the terminal and then calls Uppercase,      }
{  passing this character as a parameter.  The result returned by the }
{  function is displayed on the terminal.  This process continues     }
{  until the user enters the character # to terminate the test run.   }
{---------------------------------------------------------------------}

var
  Letter : char;            { character read from the terminal }
  Result : char;            { result returned by the function Uppercase }

{*********************************************************************}

function Uppercase(Letter : char) : char;

  {-------------------------------------------------------------------}
  {  Uppercase is used to convert alphabetic characters to upper      }
  {  case.  If the input parameter is a lower case letter             }
  {  ('a' through 'z'), the value of the function is the corresponding}
  {  upper case letter ('A' through 'Z').  If the input parameter is  }
  {  any other character, the value of the function is equal to the   }
  {  input parameter.                                                 }
  {                                                                   }
  {  Input parameters:                                                }
  {    Letter - character to be converted to upper case               }
  {                                                                   }
  {  Output parameters : None                                         }
  {                                                                   }
  {  Function value : the value of the input parameter Letter,        }
  {                   converted to upper case if it was originally    }
  {                   in the range 'a' through 'z'                    }
  {-------------------------------------------------------------------}

  var
    ConvertedLetter : char;       { the function value being computed }
    DistancePastA : integer;      { the distance in the alphabet between
                                    the letter being converted and 'a' }
  begin  { Uppercase }

    { if the input parameter is a lower case letter, convert it to
      the corresponding upper case letter.  otherwise, the converted
      letter is set equal to the input parameter. }

    if (Letter >= 'a') and (Letter <= 'z') then
      begin
        DistancePastA := ord(Letter) - ord('a');
        ConvertedLetter := chr(ord('A') + DistancePastA)
      end  { if }
    else
      ConvertedLetter := Letter;

    { set the function value }

    Uppercase := ConvertedLetter

  end;  { Uppercase }

{*********************************************************************}

procedure ReadInput(var Letter : char);

  {-------------------------------------------------------------------}
  {  ReadInput prompts the user to enter a character from the         }
  {  terminal.  The character read is returned in the parameter       }
  {  Letter.                                                          }
  {                                                                   }
  {  Input parameters: none                                           }
  {                                                                   }
  {  Output parameters:                                               }
  {    Letter - the character read from the terminal                  }
  {-------------------------------------------------------------------}

  begin  { ReadInput }

    write('Enter input for function Uppercase: ');
    readln(Letter)

  end;  { ReadInput }

{*********************************************************************}

begin  { main program }

  { read the first character from the terminal }

  ReadInput(Letter);

  { apply the function Uppercase and display the result.  continue to read
    characters and display results until the user enters the character # }

  while Letter <> '#' do
    begin
      Result := Uppercase(Letter);
      writeln('Function value is ',Result);
      ReadInput(Letter)
    end  { while }

end.

